<script lang="ts">
import Vue from 'vue';
import SlpCloseModal from '../../static/nuxt-images/video-carousels/close-modal-icon.vue';

export default Vue.extend({
  components: {
    SlpCloseModal,
  },
  mounted() {
    // Done to prevent scrolling on the content behind the modal
    document.querySelector('body').classList.add('noScroll');
    this.$refs.modalCloseButton.focus();
  },
  destroyed() {
    document.querySelector('body').classList.remove('noScroll');
  },
  methods: {
    emitClose() {
      this.$emit('close');
    },
  },
});
</script>

<template>
  <div class="backdrop" @click.self="emitClose">
    <div
      role="dialog"
      aria-modal="true"
      class="modal"
      data-aos="zoom-in"
      data-aos-duration="300"
    >
      <button
        ref="modalCloseButton"
        aria-label="Close dialog"
        type="button"
        class="close-button"
        @click="emitClose"
      >
        <SlpCloseModal />
      </button>
      <div class="modal__content">
        <slot></slot>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.backdrop {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background-color: rgba($color-surface-700, 0.85);
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 1026;
}

.close-button {
  cursor: pointer;
  width: 30px;
  text-align: center;
}

.modal {
  background: white;
  display: flex;
  flex-direction: column;
  border-radius: 3px;
  position: relative;
  z-index: 1022;
  margin: 0 1rem;
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-96;
  }
  &__content {
    box-sizing: content-box;
  }
}

.close-button {
  position: absolute;
  top: -$spacing-48;
  right: -44px;
  width: 44px;
  height: 37px;
  border: none;
  border-radius: 50%;
  cursor: pointer;
  @media (max-width: $breakpoint-lg) {
    right: 0;
  }
}
</style>
